      module Datred_mod
      real :: abskou(19,101) = reshape ((/
     1 1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,
     2 1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,
     3 1.16,1.16,1.16,1.16,1.16,1.16,1.16,1.16,1.16,1.16,
     4 1.16,1.16,1.16,1.16,1.16,1.16,1.16,1.16,1.16,
     5 1.35,1.35,1.35,1.34,1.34,1.34,1.34,1.34,1.34,1.34,
     6 1.33,1.33,1.33,1.33,1.33,1.33,1.33,1.33,1.33,
     7 1.56,1.56,1.56,1.55,1.55,1.55,1.55,1.54,1.54,1.53,
     8 1.53,1.53,1.52,1.52,1.51,1.51,1.51,1.51,1.51,
     9 1.80,1.80,1.80,1.79,1.79,1.78,1.78,1.77,1.76,1.75,
     a 1.74,1.73,1.73,1.72,1.71,1.70,1.70,1.70,1.70,
     1 2.08,2.07,2.07,2.06,2.06,2.05,2.03,2.02,2.01,1.99,
     2 1.97,1.96,1.94,1.93,1.92,1.91,1.90,1.90,1.90,
     3 2.39,2.39,2.38,2.37,2.36,2.34,2.32,2.30,2.27,2.25,
     4 2.23,2.20,2.18,2.16,2.14,2.13,2.11,2.11,2.11,
     5 2.75,2.74,2.73,2.72,2.70,2.67,2.64,2.60,2.57,2.53,
     6 2.50,2.46,2.43,2.40,2.37,2.35,2.33,2.32,2.32,
     7 3.15,3.15,3.13,3.11,3.07,3.03,2.99,2.94,2.89,2.83,
     8 2.78,2.73,2.69,2.65,2.61,2.58,2.56,2.55,2.55,
     9 3.61,3.60,3.58,3.54,3.50,3.44,3.37,3.30,3.23,3.16,
     a 3.09,3.02,2.96,2.91,2.86,2.82,2.80,2.78,2.77,
     1 4.12,4.11,4.08,4.03,3.96,3.88,3.79,3.70,3.60,3.50,
     2 3.41,3.33,3.25,3.18,3.12,3.07,3.04,3.02,3.01,
     3 4.70,4.69,4.64,4.57,4.48,4.37,4.25,4.12,3.99,3.87,
     4 3.75,3.64,3.55,3.46,3.39,3.33,3.28,3.26,3.25,
     5 5.35,5.33,5.27,5.17,5.05,4.90,4.74,4.57,4.41,4.25,
     6 4.11,3.97,3.85,3.75,3.66,3.59,3.54,3.50,3.49,
     7 6.08,6.05,5.97,5.84,5.67,5.47,5.27,5.06,4.85,4.66,
     8 4.48,4.32,4.17,4.04,3.94,3.85,3.79,3.75,3.73,
     9 6.90,6.86,6.75,6.57,6.35,6.10,5.83,5.57,5.32,5.08,
     a 4.86,4.67,4.49,4.34,4.22,4.12,4.05,4.00,3.98,
     1 7.80,7.75,7.60,7.38,7.09,6.77,6.44,6.11,5.81,5.52,
     2 5.26,5.03,4.83,4.65,4.51,4.39,4.31,4.26,4.23,
     3 8.81,8.74,8.55,8.25,7.89,7.49,7.08,6.69,6.32,5.98,
     4 5.67,5.40,5.17,4.97,4.80,4.67,4.57,4.51,4.48,
     5 9.92,9.83,9.59,9.21,8.76,8.26,7.76,7.29,6.85,6.45,
     6 6.10,5.78,5.51,5.28,5.09,4.94,4.83,4.77,4.74,
     7 11.2,11.0,10.7,10.3,9.69,9.08,8.48,7.92,7.40,6.94,
     8 6.53,6.17,5.87,5.60,5.39,5.22,5.10,5.02,4.99,
     9 12.5,12.4,12.0,11.4,10.7,9.95,9.24,8.58,7.98,7.44,
     a 6.97,6.57,6.22,5.93,5.69,5.50,5.37,5.28,5.25,
     1 14.0,13.8,13.3,12.6,11.8,10.9,10.0,9.26,8.57,7.96,
     2 7.43,6.97,6.59,6.26,5.99,5.78,5.63,5.54,5.50,
     3 15.6,15.4,14.8,13.9,12.9,11.8,10.9,9.97,9.18,8.49,
     4 7.89,7.38,6.95,6.59,6.30,6.07,5.90,5.80,5.76,
     5 17.4,17.1,16.4,15.3,14.1,12.9,11.7,10.7,9.80,9.03,
     6 8.36,7.80,7.33,6.93,6.61,6.36,6.17,6.06,6.02,
     7 19.4,19.0,18.1,16.8,15.3,13.9,12.6,11.4,10.4,9.57,
     8 8.84,8.22,7.70,7.27,6.92,6.64,6.45,6.32,6.28,
     9 21.5,21.0,19.9,18.4,16.7,15.0,13.5,12.2,11.1,10.1,
     a 9.32,8.65,8.08,7.61,7.23,6.93,6.72,6.59,6.54,
     1 23.8,23.3,21.9,20.0,18.1,16.2,14.5,13.0,11.7,10.7,
     2 9.81,9.07,8.46,7.95,7.54,7.23,6.99,6.85,6.80,
     3 26.3,25.6,24.0,21.8,19.5,17.3,15.4,13.8,12.4,11.3,
     4 10.3,9.51,8.85,8.30,7.86,7.52,7.27,7.12,7.06,
     5 29.0,28.2,26.2,23.7,21.0,18.6,16.4,14.6,13.1,11.8,
     6 10.8,9.94,9.23,8.64,8.17,7.81,7.54,7.38,7.33,
     7 31.9,30.9,28.6,25.6,22.6,19.8,17.4,15.4,13.8,12.4,
     8 11.3,10.4,9.62,8.99,8.49,8.10,7.82,7.65,7.59,
     9 35.0,33.9,31.2,27.7,24.2,21.1,18.5,16.3,14.5,13.0,
     a 11.8,10.8,10.0,9.34,8.81,8.40,8.10,7.92,7.85,
     1 38.4,37.0,33.9,29.9,25.9,22.4,19.5,17.1,15.2,13.6,
     2 12.3,11.3,10.4,9.70,9.13,8.70,8.38,8.18,8.11,
     3 42.0,40.4,36.7,32.1,27.7,23.8,20.6,18.0,15.9,14.2,
     4 12.8,11.7,10.8,10.0,9.45,8.99,8.66,8.45,8.38,
     5 45.8,43.9,39.7,34.4,29.5,25.2,21.7,18.9,16.6,14.8,
     6 13.4,12.2,11.2,10.4,9.77,9.29,8.94,8.72,8.64,
     7 49.9,47.7,42.8,36.8,31.3,26.6,22.8,19.8,17.4,15.4,
     8 13.9,12.6,11.6,10.8,10.1,9.59,9.21,8.99,8.90,
     9 54.3,51.7,46.0,39.3,33.2,28.1,23.9,20.7,18.1,16.1,
     a 14.4,13.1,12.0,11.1,10.4,9.88,9.49,9.25,9.17,
     1 58.9,56.0,49.5,41.9,35.2,29.5,25.1,21.6,18.9,16.7,
     2 14.9,13.5,12.4,11.5,10.7,10.2,9.77,9.52,9.43,
     3 63.8,60.4,53.0,44.6,37.1,31.0,26.2,22.5,19.6,17.3,
     4 15.5,14.0,12.8,11.8,11.1,10.5,10.1,9.79,9.69,
     5 69.0,65.1,56.8,47.3,39.2,32.6,27.4,23.4,20.4,17.9,
     6 16.0,14.5,13.2,12.2,11.4,10.8,10.3,10.1,9.96,
     7 74.6,70.1,60.6,50.2,41.2,34.1,28.6,24.4,21.1,18.6,
     8 16.5,14.9,13.6,12.6,11.7,11.1,10.6,10.3,10.2,
     9 80.4,75.3,64.6,53.1,43.3,35.7,29.8,25.3,21.9,19.2,
     a 17.1,15.4,14.0,12.9,12.0,11.4,10.9,10.6,10.5,
     1 86.5,80.7,68.8,56.0,45.5,37.2,31.0,26.3,22.7,19.8,
     2 17.6,15.8,14.4,13.3,12.4,11.7,11.2,10.9,10.8,
     3 93.0,86.4,73.1,59.1,47.6,38.8,32.2,27.2,23.4,20.5,
     4 18.2,16.3,14.8,13.6,12.7,12.0,11.5,11.1,11.0,
     5 99.8,92.4,77.5,62.2,49.9,40.5,33.4,28.2,24.2,21.1,
     6 18.7,16.8,15.2,14.0,13.0,12.3,11.7,11.4,11.3,
     7 107.,98.6,82.1,65.3,52.1,42.1,34.7,29.2,25.0,21.8,
     8 19.3,17.2,15.7,14.4,13.4,12.6,12.0,11.7,11.5,
     9 114.,105.,86.8,68.6,54.4,43.7,35.9,30.1,25.8,22.4,
     a 19.8,17.7,16.1,14.7,13.7,12.9,12.3,11.9,11.8,
     1 122.,112.,91.7,71.9,56.7,45.4,37.2,31.1,26.6,23.1,
     2 20.3,18.2,16.5,15.1,14.0,13.2,12.6,12.2,12.1,
     3 130.,119.,96.7,75.2,59.0,47.1,38.4,32.1,27.4,23.7,
     4 20.9,18.7,16.9,15.5,14.3,13.5,12.9,12.5,12.3,
     5 139.,126.,102.,78.6,61.3,48.8,39.7,33.1,28.1,24.4,
     6 21.4,19.1,17.3,15.8,14.7,13.8,13.2,12.8,12.6,
     7 148.,134.,107.,82.1,63.7,50.5,41.0,34.1,28.9,25.0,
     8 22.0,19.6,17.7,16.2,15.0,14.1,13.4,13.0,12.9,
     9 157.,141.,112.,85.6,66.1,52.2,42.2,35.1,29.7,25.7,
     a 22.6,20.1,18.1,16.6,15.3,14.4,13.7,13.3,13.1,
     1 167.,150.,118.,89.1,68.5,53.9,43.5,36.1,30.5,26.4,
     2 23.1,20.6,18.5,16.9,15.7,14.7,14.0,13.6,13.4,
     3 177.,158.,124.,92.7,71.0,55.6,44.8,37.1,31.3,27.0,
     4 23.7,21.0,19.0,17.3,16.0,15.0,14.3,13.8,13.7,
     5 188.,167.,129.,96.4,73.4,57.4,46.1,38.1,32.2,27.7,
     6 24.2,21.5,19.4,17.7,16.3,15.3,14.6,14.1,13.9,
     7 199.,176.,135.,100.,75.9,59.2,47.4,39.1,33.0,28.3,
     8 24.8,22.0,19.8,18.0,16.7,15.6,14.9,14.4,14.2,
     9 210.,185.,141.,104.,78.4,60.9,48.8,40.1,33.8,29.0,
     a 25.3,22.5,20.2,18.4,17.0,15.9,15.1,14.6,14.5,
     1 222.,194.,147.,108.,80.9,62.7,50.1,41.1,34.6,29.7,
     2 25.9,22.9,20.6,18.8,17.3,16.2,15.4,14.9,14.7,
     3 234.,204.,153.,111.,83.5,64.5,51.4,42.2,35.4,30.3,
     4 26.4,23.4,21.0,19.1,17.7,16.5,15.7,15.2,15.0,
     5 247.,214.,160.,115.,86.0,66.3,52.7,43.2,36.2,31.0,
     6 27.0,23.9,21.5,19.5,18.0,16.8,16.0,15.5,15.3,
     7 260.,224.,166.,119.,88.6,68.1,54.1,44.2,37.0,31.7,
     8 27.6,24.4,21.9,19.9,18.3,17.2,16.3,15.7,15.5,
     9 274.,235.,173.,123.,91.2,69.9,55.4,45.2,37.9,32.3,
     a 28.1,24.9,22.3,20.3,18.7,17.5,16.6,16.0,15.8,
     1 288.,246.,179.,127.,93.8,71.7,56.8,46.3,38.7,33.0,
     2 28.7,25.3,22.7,20.6,19.0,17.8,16.8,16.3,16.1,
     3 303.,257.,186.,131.,96.4,73.6,58.1,47.3,39.5,33.7,
     4 29.3,25.8,23.1,21.0,19.3,18.1,17.1,16.5,16.3,
     5 318.,269.,193.,135.,99.1,75.4,59.5,48.4,40.3,34.4,
     6 29.8,26.3,23.6,21.4,19.7,18.4,17.4,16.8,16.6,
     7 334.,280.,200.,139.,102.,77.2,60.8,49.4,41.2,35.0,
     8 30.4,26.8,24.0,21.7,20.0,18.7,17.7,17.1,16.9,
     9 350.,293.,207.,143.,104.,79.1,62.2,50.4,42.0,35.7,
     a 31.0,27.3,24.4,22.1,20.3,19.0,18.0,17.4,17.1,
     1 366.,305.,214.,148.,107.,81.0,63.5,51.5,42.8,36.4,
     2 31.5,27.8,24.8,22.5,20.7,19.3,18.3,17.6,17.4,
     3 383.,318.,221.,152.,110.,82.8,64.9,52.5,43.6,37.1,
     4 32.1,28.2,25.2,22.9,21.0,19.6,18.5,17.9,17.7,
     5 401.,331.,229.,156.,112.,84.7,66.3,53.6,44.5,37.8,
     6 32.7,28.7,25.7,23.2,21.3,19.9,18.8,18.2,17.9,
     7 419.,344.,236.,160.,115.,86.6,67.7,54.6,45.3,38.4,
     8 33.2,29.2,26.1,23.6,21.7,20.2,19.1,18.4,18.2,
     9 438.,357.,244.,165.,118.,88.5,69.0,55.7,46.1,39.1,
     a 33.8,29.7,26.5,24.0,22.0,20.5,19.4,18.7,18.4,
     1 457.,371.,251.,169.,121.,90.4,70.4,56.7,47.0,39.8,
     2 34.4,30.2,26.9,24.3,22.3,20.8,19.7,19.0,18.7,
     3 477.,385.,259.,173.,123.,92.2,71.8,57.8,47.8,40.5,
     4 34.9,30.7,27.3,24.7,22.7,21.1,20.0,19.3,19.0,
     5 498.,400.,267.,177.,126.,94.1,73.2,58.9,48.7,41.2,
     6 35.5,31.1,27.8,25.1,23.0,21.4,20.3,19.5,19.2,
     7 519.,415.,275.,182.,129.,96.0,74.6,59.9,49.5,41.8,
     8 36.1,31.6,28.2,25.5,23.4,21.7,20.5,19.8,19.5,
     9 540.,430.,283.,186.,132.,98.0,76.0,61.0,50.3,42.5,
     a 36.6,32.1,28.6,25.8,23.7,22.1,20.8,20.1,19.8,
     1 563.,445.,291.,191.,135.,99.9,77.4,62.0,51.2,43.2,
     2 37.2,32.6,29.0,26.2,24.0,22.4,21.1,20.3,20.0,
     3 585.,460.,299.,195.,137.,102.,78.8,63.1,52.0,43.9,
     4 37.8,33.1,29.4,26.6,24.4,22.7,21.4,20.6,20.3,
     5 609.,476.,307.,200.,140.,104.,80.2,64.2,52.8,44.6,
     6 38.4,33.6,29.9,27.0,24.7,23.0,21.7,20.9,20.6,
     7 633.,493.,315.,204.,143.,106.,81.6,65.2,53.7,45.3,
     8 38.9,34.1,30.3,27.3,25.0,23.3,22.0,21.2,20.8,
     9 657.,509.,324.,209.,146.,108.,83.0,66.3,54.5,45.9,
     a 39.5,34.6,30.7,27.7,25.4,23.6,22.3,21.4,21.1,
     1 683.,526.,332.,213.,149.,110.,84.4,67.4,55.4,46.6,
     2 40.1,35.0,31.1,28.1,25.7,23.9,22.5,21.7,21.4,
     3 709.,543.,341.,218.,152.,111.,85.8,68.4,56.2,47.3,
     4 40.6,35.5,31.6,28.5,26.0,24.2,22.8,22.0,21.6,
     5 735.,560.,349.,222.,154.,113.,87.2,69.5,57.1,48.0,
     6 41.2,36.0,32.0,28.8,26.4,24.5,23.1,22.2,21.9,
     7 762.,578.,358.,227.,157.,115.,88.6,70.6,57.9,48.7,
     8 41.8,36.5,32.4,29.2,26.7,24.8,23.4,22.5,22.2,
     9 790.,596.,367.,232.,160.,117.,90.1,71.7,58.8,49.4,
     a 42.4,37.0,32.9,29.6,27.1,25.1,23.7,22.8,22.4,
     1 819.,614.,375.,236.,163.,119.,91.5,72.7,59.6,50.1,
     2 42.9,37.5,33.3,30.0,27.4,25.4,24.0,23.1,22.7,
     3 848.,632.,384.,241.,166.,121.,92.9,73.8,60.4,50.7,
     4 43.5,38.0,33.7,30.3,27.7,25.7,24.3,23.3,23.0,
     5 878.,651.,393.,246.,169.,123.,94.3,74.9,61.3,51.4,
     6 44.1,38.5,34.1,30.7,28.1,26.1,24.5,23.6,23.2,
     7 909.,670.,402.,250.,172.,125.,95.8,76.0,62.1,52.1,
     8 44.7,39.0,34.6,31.1,28.4,26.4,24.8,23.9,23.5,
     9 940.,690.,411.,255.,175.,127.,97.2,77.1,63.0,52.8,
     a 45.2,39.5,35.0,31.5,28.7,26.7,25.1,24.2,23.8,
     1 972.,709.,420.,260.,178.,129.,98.6,78.2,63.9,53.5,
     2 45.8,39.9,35.4,31.8,29.1,27.0,25.4,24.4,24.0,
     31005.,729.,429.,264.,180.,131.,100.,79.3,64.7,54.2,
     4 46.4,40.4,35.8,32.2,29.4,27.3,25.7,24.7,24.3,
     51038.,749.,439.,269.,183.,133.,101.,80.4,65.6,54.9,
     6 46.9,40.9,36.2,32.6,29.7,27.6,26.0,25.0,24.6,
     71072.,770.,448.,274.,186.,135.,103.,81.5,66.4,55.6,
     8 47.5,41.3,36.6,32.9,30.1,27.9,26.3,25.2,24.8,
     91107.,791.,457.,279.,189.,137.,104.,82.6,67.3,56.3,
     a 48.0,41.8,37.0,33.3,30.4,28.2,26.5,25.5,25.1,
     11143.,812.,467.,284.,192.,139.,106.,83.7,68.2,57.0,
     2 48.6,42.2,37.4,33.6,30.7,28.5,26.8,25.8,25.4,
     31180.,833.,476.,288.,195.,141.,107.,84.8,69.1,57.7,
     4 49.1,42.7,37.7,33.9,31.0,28.8,27.1,26.1,25.6,
     51217.,855.,485.,293.,198.,143.,109.,85.9,69.9,58.4,
     6 49.6,43.1,38.1,34.3,31.4,29.1,27.4,26.3,25.9,
     71255.,877.,495.,298.,201.,145.,110.,87.0,70.8,59.1,
     8 50.2,43.5,38.4,34.6,31.7,29.5,27.7,26.6,26.2,
     91294.,899.,505.,303.,204.,147.,112.,88.2,71.7,59.8,
     a 50.7,43.9,38.7,34.9,32.0,29.8,28.0,26.9,26.4,
     11333.,921.,514.,308.,207.,149.,113.,89.3,72.6,60.5,
     2 51.2,44.2,39.0,35.2,32.3,30.1,28.3,27.2,26.7/),
     3         shape(abskou))

C  ---------------------------------------------------------------------

      integer :: SEType,SESpHarm=1,SEScales=2,SEAll=3,CovTest,
     1           NUniXShape,NAllXShape,ScFrMethodStepLike=0,
     2           ScFrMethodInterpol=1,
     2           NRefMaxXShape=-1,NCyklSemiEmpir=500,LSMethodSemiEmpir=2
      integer, allocatable :: RunScM(:,:),RunScGrN(:,:)
      logical MameDirCos
      logical, allocatable :: ScBrat(:,:)
      real, allocatable :: ScFrame(:,:),SpHAlm(:,:)
      character*80 :: FormatEqv='(.i4,2f8.2,i4,6f8.5,f15.3)'
      real ::  CutMinXShape=-1.,CutMaxXShape=-1.,FLimCullXShape=-1.,
     1         TlumSemiEmpir=1.,MarqLamSemiEmpir=.001

C  ---------------------------------------------------------------------

      integer, allocatable :: ihar(:,:),irec(:),irecp(:),ireca(:),
     1                        ipor(:),inca(:),KPhAr(:),MltAr(:),
     2                        NAveRedAr(:)
      real, allocatable :: riar(:),rsar(:),gridp(:,:),RIAveAr(:),
     1                     RSAveAr(:),DiffAveAr(:),RunCCDAr(:)

C  ---------------------------------------------------------------------

      integer, allocatable :: HDr(:,:),HDrTw(:),ColDr(:),PorDr(:),
     1                        FlgAr(:),HCondAr(:,:),HCondAveAr(:),
     2                        Ave2Org(:,:),HCondWdFAr(:),FoInd2Ave(:),
     3                        RefBlockAr(:),ICullAr(:),IXDr(:),OrderX(:)
      integer NDrAlloc,SimNDr,NRefRead,NRefReadObs,NRefAlloc,
     1        NAveRedMax,NAveMax,NAveRed,NAve,NTotallyCulled,GasketUsed,
     2        DiamondUsed,DisplaySelect,NRefWdF,NRefWdFMax,XUse,YUse,
     3        MaxRefBlockAr,NRefBlockAr,ReflUse,XDNDat
      real, allocatable :: WdFAr(:),FoAr(:),FsAr(:),FcAr(:),RIDr(:),
     1                     RSDr(:),XDr(:),YDr(:),RadDr(:),IcAr(:)
      real RadDrMax,GasketTheta(22),GasketDeltaTheta,DiamondTheta(22),
     1     DiamondDeltaTheta,ScSgTest,ObsLevelCull
      logical :: CulledExist,OnceMeasuredExist,TwiceMeasuredExist,
     1           CompletelyExcludedExist,Zoomed,XDCteI,XLinear=.true.

C  ---------------------------------------------------------------------

      logical :: UseInSGTest(:),TakeSGTwin = .false.,
     1           TakeOldTwin = .false.
      allocatable UseInSGTest
      integer iLaueString,nLaueString,OLaueString(:),RLaueString(:),
     1        nSelLaue,IdSymmFull,IdSymmFullTr
      integer :: TakeSGTwinOld=-1, TakeOldTwinOld=-1
      character*80 LaueString(:)
      allocatable LaueString,OLaueString,RLaueString
      real TrMPOrg(36)

C  ---------------------------------------------------------------------

      integer :: SimType=1,SimDir(3)=(/0,0,1/),SimDirSel=3,
     1           SimMainLayer=0,SimSatLayer(3)=(/0,0,0/),
     2           SimColorMain(3),SimColorSat,SimColorPlus,SimColorMinus,
     3           SimColorUnobs,SimIZ,IdSim,SimColorTwin(18)
      logical :: SimAve=.true.,SimComplete=.true.,SimUseShading=.false.,
     1           SimUseScaledRad=.true.,SimDrawSat=.true.,
     2           SimDrawUnobs=.true.,SimProjectSat=.false.,
     3           SimDrawTwins=.false.,SimUseDefaultNet=.true.
      real ::    SimRadMin=1.,SimRadMax=5.,SimScope=50.,
     1           SimValRed=20.,SimDepth=0.,
     2           SinThLMax,SimValMax,SimDrLayer,SimTr(3,3),SimTrI(3,3),
     3           SimScale,SimLayer,
     4           XMinBasVec,XMaxBasVec,YMinBasVec,YMaxBasVec,
     5           SimNet(2,2)=reshape((/1.,0.,0.,1./),shape(SimNet))

C  ---------------------------------------------------------------------

      integer NRunSENJUMax,NRunSENJU,RunSENJU(:)
      allocatable RunSENJU
      end
